;; Problem 21
;; 05 July 2002

;; Let d(n) be defined as the sum of proper divisors of n (numbers
;; less than n which divide evenly into n).

;;  If d(a) = b and d(b) = a, where a b, then a and b are an amicable
;;  pair and each of a and b are called amicable numbers.

;; For example, the proper divisors of 220 are 1, 2, 4, 5, 10, 11, 20,
;; 22, 44, 55 and 110; therefore d(220) = 284. The proper divisors of
;; 284 are 1, 2, 4, 71 and 142; so d(284) = 220.

;; Evaluate the sum of all the amicable numbers under 10000.

(defmacro acollect (&body body)
  (let ((resv (gensym)))
    `(let ((it (list))
	   (,resv nil))
      (setf ,resv (progn ,@body))
      (values it ,resv))))

;; (acollect
;;   (loop for ii from 1 to 10
;; 	do
;; 	(push ii it))
;;   "23")

(defun factor (num)
  (acollect
    (push 1 it)
    (loop for ff from 2 to (ceiling (/ num 2))
	  do
;; 	  (format t "ff:~a num:~a div?~a~&"
;; 		  ff
;; 		  num
;; 		  (= 0 (mod num ff)))
	  (when (and (= 0 (mod num ff))
		     (not (member ff it)))
	    (push ff it)))))

(sort (factor 220) #'<)
;; => (1 2 4 5 10 11 20 22 44 55 110)

(defun sum-factors (num)
  (apply #'+ (factor num)))

;(sum-factors 220) 284
;(sum-factors 284) 220

(defun is-amicable (num)
  (let* ((sum1 (sum-factors num))
	 (sum2 (sum-factors sum1)))
    (= num sum2)))

(is-amicable 220)

(defun amicable-under (num)
  (acollect
    (loop for ii from 2 to num
	  do
	  ;(format t "testing: ~a~&" ii)
	  (when (is-amicable ii)
	    (format t "found amicable: ~a => ~a~&" ii (sum-factors ii))
	    ;; apparently you don't include identities, but only non equal pairs
	    (when (not (= ii (sum-factors ii)))
	      (push ii it))))))

; (amicable-under 1000)
; (amicable-under 10000)
(time
 (format t "total: ~a~&"
	 (apply #'+ (amicable-under 10000))))  ; total: 31626

; (8128 6368 6232 5564 5020 2924 2620 1210 1184 496 284 220 28 6)
